<template>
  <header>
    <div class="container">
      <div class="search-input">
        <v-icon color="blue"> mdi-magnify </v-icon>
        <input ref="search" type="text" v-model="search_data" @input="search" />
        <button>
          <v-icon color="grey"> mdi-close </v-icon>
        </button>
      </div>
    </div>
  </header>
  <div class="search">
    <div class="container">
      <div class="search-tabs">
        <v-tabs v-model="selected_tab" color="blue" grow>
          <v-tab v-for="tab in search_tabs" :key="tab.value" :value="tab.value">
            <v-icon>{{ tab.icon }}</v-icon>
            {{ tab.title }}
          </v-tab>
        </v-tabs>
      </div>
      <div class="search-results">
        <div
          class="search-organisations"
          v-if="selected_tab === 'organisations'"
        >
          <organisation-preview
            v-for="organisation in search_results"
            :key="organisation.id"
            :organisation="organisation"
          />
        </div>
        <div class="search-volunteers" v-else>
          <volunteer-preview
            v-for="volunteer in search_results"
            :key="volunteer.id"
            :volunteer="volunteer"
          />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapActions } from "vuex";
import OrganisationPreview from "@/components/OrganisationPreview";
import VolunteerPreview from "@/components/VolunteerPreview";

export default {
  name: "SearchView",
  components: { VolunteerPreview, OrganisationPreview },
  data() {
    return {
      search_data: "",
      search_results: "",
      selected_tab: "organisations",
      search_tabs: [
        {
          title: "Организации",
          icon: "mdi-home-city-outline",
          value: "organisations",
        },
        {
          title: "Волонтеры",
          icon: "mdi-account-outline",
          value: "volunteers",
        },
      ],
    };
  },

  watch: {
    selected_tab() {
      this.search_data = "";
      this.search_results = "";
    },
  },

  methods: {
    ...mapActions({
      searchOrganisations: "search/searchOrganisations",
      searchUsers: "search/searchUsers",
    }),

    search() {
      if (this.selected_tab === "organisations" && this.search_data.length) {
        this.searchOrganisations(this.search_data).then((response) => {
          this.search_results = response.data.data;
        });
      }

      if (this.selected_tab === "volunteers" && this.search_data.length) {
        this.searchUsers(this.search_data).then((response) => {
          this.search_results = response.data.data;
        });
      }
    },
  },
};
</script>

<style scoped lang="scss">
header {
  height: 64px;
  background-color: $blue2;
  display: flex;
  align-items: center;
  justify-content: center;
  position: fixed;
  top: 0;
  width: 100%;
  z-index: 20;
}

.search {
  &-input {
    padding: ($base-space * 3) $base-space;
    background: $white;
    border-radius: 4px;
    display: flex;
    align-items: center;
    justify-content: space-between;
    width: 100%;
    > input {
      width: 100%;
      padding: 0 ($base-space * 2);
      outline: none;
    }
  }
  &-wrapper {
    position: absolute;
    width: 100%;
    height: calc(100% - 132px);
    background: $white;
    top: 64px;
    left: 0;
    z-index: 10;
    padding: ($base-space * 2) 0;
    overflow: auto;
  }
  &-tabs {
    margin: 0 0 ($base-space * 6);
  }
  &-organisations {
    display: grid;
    grid-template-columns: 1fr;
    grid-gap: $base-space * 4;
    > .organisation-preview {
      width: 100%;
    }
  }
  &-volunteers {
    display: grid;
    grid-template-columns: repeat(2, 1fr);
    grid-gap: $base-space * 4;
    > .volunteer-preview {
      width: 100%;
    }
  }
}
</style>
